' 
'
'                             PB Main Template
'
    #include "\pbwin80\include\win32api.inc"
    DECLARE FUNCTION ltok(ByVal src as DWORD,ByVal pArray as DWORD) as DWORD

' 

FUNCTION PBmain as LONG

    LOCAL flen  as DWORD
    LOCAL arr   as DWORD
    LOCAL ptext as DWORD
    LOCAL lcnt  as DWORD
    LOCAL cntr  as DWORD

    Open "\pbwin80\include\win32api.inc" for Binary as #1
      flen = lof(1)
      Get$ #1, flen, src$
    Close #1

    ptext = StrPtr(src$)                    ' get the source address

    lcnt = ltok(ptext,ByVal VarPtr(arr))    ' tokenise lines in entire file
    Dim tlines(lcnt) as ASCIIZ PTR at arr   ' treat GlobalAlloc() array as
                                            ' ASCIIZ pointers

  ' --------------------------------------------------------------
  ' display the results. This is a slow operation on a large file.
  ' --------------------------------------------------------------
    cntr = 0
    Do
      StdOut @tlines(cntr)
      ! add cntr, 1
    Loop while cntr < lcnt

    GlobalFree arr                          ' release the memory allocated
                                            ' in "ltok".
End FUNCTION

' 

FUNCTION ltok(ByVal src as DWORD,ByVal pArray as DWORD) as DWORD

    #REGISTER NONE

    LOCAL pTxt as DWORD
    LOCAL pmem as DWORD
    LOCAL bcnt as DWORD

  ' ---------------------------------------------------------------
  ' tokenise lines in a text source writing an array of pointers
  ' to the address of "pArray" and returning the line count in EAX.
  '
  ' The address written to the variable "pArray" should be released
  ' within the same scope as the variable with a call to GlobalFree()
  ' when the pointer array is no longer required.
  '
  ' EXAMPLE
  ' cnt = ltok(ptxt,ByVal VarPtr(harr))    ' tokenise source lines
  ' dim tline(cnt) as ASCIIZ PTR at harr   ' treat it as an ASCIIZ PTR array.
  ' .....
  ' GlobalFree harr                        ' deallocate memory from "ltok"
  ' ---------------------------------------------------------------

    pTxt = src

    ! mov edi, 1                      ' set counter to 1 in case of no trailing CRLF

    ! mov esi, pTxt
    ! sub esi, 1
  ' ----------------
  ' count line feeds
  ' ----------------
  lbl0:
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]
    ! test edx, edx                   ' test for terminator
    ! jz lbl1
    ! cmp edx, 10                     ' test for line feed
    ! jne lbl0
    ! add edi, 1                      ' lf count in EDI
    ! jmp lbl0
  lbl1:
  ' --------------------
  ' multiply result by 4
  ' --------------------
    ! add edi, edi
    ! add edi, edi
    ! mov bcnt, edi

    pmem = GlobalAlloc(%GMEM_FIXED or %GMEM_ZEROINIT,bcnt)

    ! mov edi, pmem                   ' copy allocated memory address into EDI
    ! mov esi, pTxt
    ! xor eax, eax                    ' zero arg counter
    ! sub esi, 1
    ! jmp ftrim

  ' ---------------------------------

  terminate:
    ! mov BYTE PTR [esi], 0           ' terminate end of current line

  ftrim:                              ' scan to find next acceptable character
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]       ' zero extend byte
    ! test edx, edx                   ' test for zero terminator
    ! jz lout
    ! cmp edx, 32
    ! jbe ftrim                       ' scan again for 32 or less

  ' ========
    ! mov [edi], esi                  ' write current location to pointer
    ! add edi, 4                      ' set next pointer location
    ! add eax, 1                      ' increment arg count return value
  ' ========

  ttrim:                              ' scan to find the next CR or LF
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]       ' zero extend byte
    ! cmp edx, 13
    ! jg ttrim                        ' short loop on normal case

    ! je terminate
    ! cmp edx, 10                     ' extra test for ascii 10
    ! je terminate
    ! test edx, edx
    ! jnz ttrim                       ' loop back if not zero, IE TAB.

  ' ---------------------------------

  lout:
    ! mov esi, pArray                 ' load passed handle address into ESI
    ! mov ecx, pmem                   ' local memory handle into ECX
    ! mov [esi], ecx                  ' store local array handle at address of passed handle

    ! mov FUNCTION, eax               ' return the line count

END FUNCTION

' 
